<template>
  <BasicModal
    v-bind="$attrs"
    @register="register"
    title="安装授权"
    @visible-change="handleVisibleChange"
    @cancel="resetFields"
    @ok="handleConfirm"
  >
    <div class="pt-2px pr-3px zdysrk">
      <BasicForm @register="registerForm">
        <template #text="{ model, field }"> {{ model[field] }}{{ fileFlow.type }} </template>
      </BasicForm>
    </div>
  </BasicModal>
</template>
<script lang="ts">
  import { defineComponent, nextTick, onMounted, reactive, computed, h } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, FormSchema, useForm } from '/@/components/Form/index';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { remarkschemas, Addschemas } from './data';
  import { InvoiceRegister } from '/@/api/order';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { uploadApi } from '/@/api/product/index';
  import { copyTextToClipboard } from '/@/hooks/web/useCopyToClipboard';
  import { ResultEnum } from '/@/enums/httpEnum';
  import { authorizeInstalladdOrUpdate, checkMachineCode } from '/@/api/authorizeModeling';
  import dayjs from 'dayjs';
  import { otherInfoStore } from '/@/store/modules/other';

  const { t } = useI18n();
  export default defineComponent({
    components: { BasicModal, BasicForm },
    props: {
      userData: { type: Object },
    },
    emits: ['update', 'register'],
    setup(props, { emit }) {
      const otherInfo = otherInfoStore();
      const overviewInfo = computed(() => otherInfo.getOverviewInfo);
      // const overviewInfo = getOverviewInfo() || {}
      const fileFlow = reactive({
        file: null,
        id: '',
        key: '',
        type: 'down', //down-下载，equity-权益
      });
      const { createMessage, createConfirm, createSuccessModal } = useMessage();
      const schemas: FormSchema[] = [
        {
          field: 'id',
          component: 'Input',
          show: false,
          label: 'id',
        },
        {
          field: 'machineCode',
          component: 'InputTextArea',
          required: true,
          label: '机器码',
          componentProps: {
            rows: 4,
          },
          colProps: { span: 20 },
        },
      ];

      const [registerForm, { validate, resetFields, setFieldsValue, updateSchema }] = useForm({
        labelWidth: 120,
        schemas: [...Addschemas, ...schemas, ...remarkschemas],
        showActionButtonGroup: false,
        actionColOptions: {
          span: 24,
        },
      });
      onMounted(() => {});
      let addListFunc = () => {};
      const [register, { closeModal }] = useModalInner((data) => {
        data && onDataReceive(data);
      });
      async function onDataReceive(data) {
        resetFields();
        fileFlow.id = data.id;
        fileFlow.key = data.authorizeKey;
        updateSchema([
          {
            field: 'useType',
            componentProps: {
              onChange: (value) => {
                updateSchema({ field: 'projectNum', ifShow: value == '4' });
              },
            },
          },
          {
            field: 'projectNum',
            ifShow: data.useType == '4',
          },
          {
            field: 'machineCode',
            componentProps: {
              disabled: data.id ? true : false,
            },
          },
        ]);
        setFieldsValue(data);
      }
      async function handleConfirm() {
        const { id, machineCode } = await validate();
        let res = await checkMachineCode({ machineCode:machineCode.replace(/\s*/g,"") });
        console.log('res', res, !id);
        if (!id && res && res.id) {
          createConfirm({
            iconType: 'warning',
            title: () => h('span', '温馨提示'),
            content: () => h('span', `当前设备已存在授权记录。`),
            okText: '继续',
            onOk: async () => {
              handleSubmit();
            },
          });
        } else {
          createConfirm({
            iconType: 'warning',
            title: () => h('span', '温馨提示'),
            content: () => h('span', `确定要${id ? '编辑' : '新增'}授权吗？`),
            onOk: async () => {
              handleSubmit();
            },
          });
        }
      }
      const handleSubmit = async () => {
        try {
          const params = await validate();
          console.log('validate', params);
          const apiData = {
            ...params,
            snCodes:params.snCodes && params.snCodes.replace(/\s*/g,""),
            machineCode:params.machineCode.replace(/\s*/g,""),
            userId: params.id,
          };
          let res = await authorizeInstalladdOrUpdate(apiData);
          closeModal();
          resetFields();
          createSuccessModal({
            title: t('layout.setting.operatingTitle'),
            content: `安装Key：${res.authorizeKey || fileFlow.key}`,
            okText: '复制',
            onOk: async () => {
              // 双击复制
              copyTextToClipboard(res.authorizeKey || fileFlow.key);
              createMessage.success('复制成功');
            },
          });
          // createMessage.success(t('common.optSuccess'));
          emit('update');
        } catch (error) {
          console.log('not passing', error);
        }
      };
      function handleVisibleChange(v) {
        v && props.userData && nextTick(() => onDataReceive(props.userData));
      }
      return {
        register,
        registerForm,
        fileFlow,
        handleVisibleChange,
        handleSubmit,
        addListFunc,
        resetFields,
        handleConfirm,
        t,
      };
    },
  });
</script>
<style lang="less">
  .zdysrk {
    .ant-calendar-picker {
      min-width: 285px;
    }
  }
</style>
